diff --git a/README b/README
index 17dc0ee33ba2..aefdfe4f6b42 100644
--- a/README
+++ b/README
@@ -1330,21 +1330,6 @@ The following options need to be configured:
 		can be displayed via the splashscreen support or the
 		bmp command.
 
-- Compression support:
-		CONFIG_GZIP
-
-		Enabled by default to support gzip compressed images.
-
-		CONFIG_BZIP2
-
-		If this option is set, support for bzip2 compressed
-		images is included. If not, only uncompressed and gzip
-		compressed images are supported.
-
-		NOTE: the bzip2 algorithm requires a lot of RAM, so
-		the malloc area (as defined by CONFIG_SYS_MALLOC_LEN) should
-		be at least 4MB.
-
 - MII/PHY support:
 		CONFIG_PHY_CLOCK_FREQ (ppc4xx)
 
diff --git a/configs/bayleybay_defconfig b/configs/bayleybay_defconfig
index 80a817a3f32e..ee032e25f6bd 100644
--- a/configs/bayleybay_defconfig
+++ b/configs/bayleybay_defconfig
@@ -56,3 +56,4 @@ CONFIG_USB_KEYBOARD=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_11B=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/cherryhill_defconfig b/configs/cherryhill_defconfig
index c3ad39c72537..c1b6e715f4ee 100644
--- a/configs/cherryhill_defconfig
+++ b/configs/cherryhill_defconfig
@@ -41,3 +41,4 @@ CONFIG_RTL8169=y
 CONFIG_SPI=y
 CONFIG_USB_STORAGE=y
 CONFIG_USB_KEYBOARD=y
+# CONFIG_GZIP is not set
diff --git a/configs/chromebook_coral_defconfig b/configs/chromebook_coral_defconfig
index 2039ea618667..d7cab2334baa 100644
--- a/configs/chromebook_coral_defconfig
+++ b/configs/chromebook_coral_defconfig
@@ -98,4 +98,5 @@ CONFIG_SPL_FS_CBFS=y
 CONFIG_TPL_USE_TINY_PRINTF=y
 CONFIG_CMD_DHRYSTONE=y
 CONFIG_TPM=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/chromebook_link64_defconfig b/configs/chromebook_link64_defconfig
index a13f6eac80a8..75f3d2c4116d 100644
--- a/configs/chromebook_link64_defconfig
+++ b/configs/chromebook_link64_defconfig
@@ -73,3 +73,4 @@ CONFIG_VIDEO_IVYBRIDGE_IGD=y
 CONFIG_CONSOLE_SCROLL_LINES=5
 CONFIG_CMD_DHRYSTONE=y
 CONFIG_TPM=y
+# CONFIG_GZIP is not set
diff --git a/configs/chromebook_link_defconfig b/configs/chromebook_link_defconfig
index de4186cdf232..3d51ec960647 100644
--- a/configs/chromebook_link_defconfig
+++ b/configs/chromebook_link_defconfig
@@ -68,4 +68,5 @@ CONFIG_VIDEO_IVYBRIDGE_IGD=y
 CONFIG_CONSOLE_SCROLL_LINES=5
 CONFIG_CMD_DHRYSTONE=y
 CONFIG_TPM=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/chromebook_samus_defconfig b/configs/chromebook_samus_defconfig
index fb4d88028c68..c18cba9cf43f 100644
--- a/configs/chromebook_samus_defconfig
+++ b/configs/chromebook_samus_defconfig
@@ -71,3 +71,4 @@ CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_11A=y
 CONFIG_CONSOLE_SCROLL_LINES=5
 CONFIG_TPM=y
+# CONFIG_GZIP is not set
diff --git a/configs/chromebook_samus_tpl_defconfig b/configs/chromebook_samus_tpl_defconfig
index a12a04b0bf17..82172ba810ca 100644
--- a/configs/chromebook_samus_tpl_defconfig
+++ b/configs/chromebook_samus_tpl_defconfig
@@ -87,3 +87,4 @@ CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_11A=y
 CONFIG_CONSOLE_SCROLL_LINES=5
 CONFIG_TPM=y
+# CONFIG_GZIP is not set
diff --git a/configs/chromebox_panther_defconfig b/configs/chromebox_panther_defconfig
index 48bcd94a6269..fd87ab262b63 100644
--- a/configs/chromebox_panther_defconfig
+++ b/configs/chromebox_panther_defconfig
@@ -55,3 +55,4 @@ CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_11A=y
 CONFIG_CONSOLE_SCROLL_LINES=5
 CONFIG_TPM=y
+# CONFIG_GZIP is not set
diff --git a/configs/conga-qeval20-qa3-e3845-internal-uart_defconfig b/configs/conga-qeval20-qa3-e3845-internal-uart_defconfig
index abf52630816b..eacc9852bd63 100644
--- a/configs/conga-qeval20-qa3-e3845-internal-uart_defconfig
+++ b/configs/conga-qeval20-qa3-e3845-internal-uart_defconfig
@@ -66,3 +66,4 @@ CONFIG_USB_KEYBOARD=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_114=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/conga-qeval20-qa3-e3845_defconfig b/configs/conga-qeval20-qa3-e3845_defconfig
index aac0ed2928c4..04b9d5eee9a9 100644
--- a/configs/conga-qeval20-qa3-e3845_defconfig
+++ b/configs/conga-qeval20-qa3-e3845_defconfig
@@ -62,3 +62,4 @@ CONFIG_USB_KEYBOARD=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_114=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/coreboot64_defconfig b/configs/coreboot64_defconfig
index 39469b52037a..6bba9ec72b76 100644
--- a/configs/coreboot64_defconfig
+++ b/configs/coreboot64_defconfig
@@ -46,3 +46,4 @@ CONFIG_SYSCON=y
 CONFIG_SOUND=y
 CONFIG_SOUND_I8254=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/coreboot_defconfig b/configs/coreboot_defconfig
index ad41c91e6e89..4a43b59e0f37 100644
--- a/configs/coreboot_defconfig
+++ b/configs/coreboot_defconfig
@@ -41,3 +41,4 @@ CONFIG_SYSCON=y
 CONFIG_SOUND=y
 CONFIG_SOUND_I8254=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/cougarcanyon2_defconfig b/configs/cougarcanyon2_defconfig
index aac8a391fdcd..4cb734477efa 100644
--- a/configs/cougarcanyon2_defconfig
+++ b/configs/cougarcanyon2_defconfig
@@ -46,3 +46,4 @@ CONFIG_SPI=y
 CONFIG_USB_STORAGE=y
 CONFIG_USB_KEYBOARD=y
 # CONFIG_VIDEO_VESA is not set
+# CONFIG_GZIP is not set
diff --git a/configs/crownbay_defconfig b/configs/crownbay_defconfig
index 06d5ce4cad90..706f5cd1c426 100644
--- a/configs/crownbay_defconfig
+++ b/configs/crownbay_defconfig
@@ -52,3 +52,4 @@ CONFIG_USB_STORAGE=y
 CONFIG_USB_KEYBOARD=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/dfi-bt700-q7x-151_defconfig b/configs/dfi-bt700-q7x-151_defconfig
index fdf686f95669..56fc28276236 100644
--- a/configs/dfi-bt700-q7x-151_defconfig
+++ b/configs/dfi-bt700-q7x-151_defconfig
@@ -61,3 +61,4 @@ CONFIG_USB_ETHER_RTL8152=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_114=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/dh_imx6_defconfig b/configs/dh_imx6_defconfig
index e0dfffa4b571..d20405e5b24e 100644
--- a/configs/dh_imx6_defconfig
+++ b/configs/dh_imx6_defconfig
@@ -100,3 +100,4 @@ CONFIG_CI_UDC=y
 CONFIG_USB_GADGET_DOWNLOAD=y
 CONFIG_WATCHDOG_TIMEOUT_MSECS=60000
 CONFIG_IMX_WATCHDOG=y
+CONFIG_BZIP2=y
diff --git a/configs/efi-x86_app_defconfig b/configs/efi-x86_app_defconfig
index 790268a1ff9c..5252659942c5 100644
--- a/configs/efi-x86_app_defconfig
+++ b/configs/efi-x86_app_defconfig
@@ -34,5 +34,6 @@ CONFIG_SYSCON=y
 # CONFIG_DM_ETH is not set
 CONFIG_DEBUG_EFI_CONSOLE=y
 # CONFIG_REGEX is not set
+# CONFIG_GZIP is not set
 CONFIG_EFI=y
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/efi-x86_payload32_defconfig b/configs/efi-x86_payload32_defconfig
index f3ee5284d545..0f5f7877070c 100644
--- a/configs/efi-x86_payload32_defconfig
+++ b/configs/efi-x86_payload32_defconfig
@@ -36,5 +36,6 @@ CONFIG_SYS_RELOC_GD_ENV_ADDR=y
 CONFIG_REGMAP=y
 CONFIG_SYSCON=y
 # CONFIG_PCI_PNP is not set
+# CONFIG_GZIP is not set
 CONFIG_EFI=y
 CONFIG_EFI_STUB=y
diff --git a/configs/efi-x86_payload64_defconfig b/configs/efi-x86_payload64_defconfig
index b83e60996603..dafad67e7e85 100644
--- a/configs/efi-x86_payload64_defconfig
+++ b/configs/efi-x86_payload64_defconfig
@@ -36,6 +36,7 @@ CONFIG_SYS_RELOC_GD_ENV_ADDR=y
 CONFIG_REGMAP=y
 CONFIG_SYSCON=y
 # CONFIG_PCI_PNP is not set
+# CONFIG_GZIP is not set
 CONFIG_EFI=y
 CONFIG_EFI_STUB=y
 CONFIG_EFI_STUB_64BIT=y
diff --git a/configs/galileo_defconfig b/configs/galileo_defconfig
index 4e2a23f63888..612fbacf997a 100644
--- a/configs/galileo_defconfig
+++ b/configs/galileo_defconfig
@@ -45,3 +45,4 @@ CONFIG_CPU=y
 CONFIG_SPI=y
 CONFIG_USB_STORAGE=y
 CONFIG_USB_KEYBOARD=y
+# CONFIG_GZIP is not set
diff --git a/configs/guruplug_defconfig b/configs/guruplug_defconfig
index 8d862696ca66..0401effee6fa 100644
--- a/configs/guruplug_defconfig
+++ b/configs/guruplug_defconfig
@@ -51,3 +51,4 @@ CONFIG_DM_USB=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_STORAGE=y
 CONFIG_LZMA=y
+CONFIG_BZIP2=y
diff --git a/configs/ib62x0_defconfig b/configs/ib62x0_defconfig
index fea69d32e9ff..ac7a794afe8a 100644
--- a/configs/ib62x0_defconfig
+++ b/configs/ib62x0_defconfig
@@ -44,3 +44,4 @@ CONFIG_USB=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_STORAGE=y
 CONFIG_LZMA=y
+CONFIG_BZIP2=y
diff --git a/configs/iconnect_defconfig b/configs/iconnect_defconfig
index 4281aa93bc4b..d5a0ecada0d7 100644
--- a/configs/iconnect_defconfig
+++ b/configs/iconnect_defconfig
@@ -39,3 +39,4 @@ CONFIG_USB=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_STORAGE=y
 CONFIG_LZMA=y
+CONFIG_BZIP2=y
diff --git a/configs/minnowmax_defconfig b/configs/minnowmax_defconfig
index 127fd5d53e03..40ed9e4120de 100644
--- a/configs/minnowmax_defconfig
+++ b/configs/minnowmax_defconfig
@@ -62,3 +62,4 @@ CONFIG_USB_KEYBOARD=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_11B=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/nsa310s_defconfig b/configs/nsa310s_defconfig
index 7a864bddf314..62edcd83f3c3 100644
--- a/configs/nsa310s_defconfig
+++ b/configs/nsa310s_defconfig
@@ -41,4 +41,5 @@ CONFIG_USB=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_STORAGE=y
 CONFIG_LZMA=y
+CONFIG_BZIP2=y
 CONFIG_OF_LIBFDT=y
diff --git a/configs/qemu-x86_64_defconfig b/configs/qemu-x86_64_defconfig
index 4e8eab531cdf..90d287b7b063 100644
--- a/configs/qemu-x86_64_defconfig
+++ b/configs/qemu-x86_64_defconfig
@@ -60,3 +60,4 @@ CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_USER=y
 CONFIG_FRAMEBUFFER_VESA_MODE=0x144
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/qemu-x86_defconfig b/configs/qemu-x86_defconfig
index 565f232b4f63..4309c2352df4 100644
--- a/configs/qemu-x86_defconfig
+++ b/configs/qemu-x86_defconfig
@@ -44,3 +44,4 @@ CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_USER=y
 CONFIG_FRAMEBUFFER_VESA_MODE=0x144
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/sheevaplug_defconfig b/configs/sheevaplug_defconfig
index d350429cada5..39939ccf6032 100644
--- a/configs/sheevaplug_defconfig
+++ b/configs/sheevaplug_defconfig
@@ -50,3 +50,4 @@ CONFIG_DM_USB=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_STORAGE=y
 CONFIG_LZMA=y
+CONFIG_BZIP2=y
diff --git a/configs/slimbootloader_defconfig b/configs/slimbootloader_defconfig
index 4a4fb1100d40..dce540342b49 100644
--- a/configs/slimbootloader_defconfig
+++ b/configs/slimbootloader_defconfig
@@ -21,3 +21,4 @@ CONFIG_REGMAP=y
 CONFIG_SYSCON=y
 # CONFIG_PCI_PNP is not set
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/som-db5800-som-6867_defconfig b/configs/som-db5800-som-6867_defconfig
index 4d7accc7c473..854381d6e716 100644
--- a/configs/som-db5800-som-6867_defconfig
+++ b/configs/som-db5800-som-6867_defconfig
@@ -57,3 +57,4 @@ CONFIG_USB_KEYBOARD=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_11A=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/theadorable-x86-conga-qa3-e3845-pcie-x4_defconfig b/configs/theadorable-x86-conga-qa3-e3845-pcie-x4_defconfig
index 7a8feee5212b..ed68f09d14a6 100644
--- a/configs/theadorable-x86-conga-qa3-e3845-pcie-x4_defconfig
+++ b/configs/theadorable-x86-conga-qa3-e3845-pcie-x4_defconfig
@@ -65,3 +65,4 @@ CONFIG_USB_ETHER_RTL8152=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_114=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/theadorable-x86-conga-qa3-e3845_defconfig b/configs/theadorable-x86-conga-qa3-e3845_defconfig
index dbbac6b10354..c414b95f6f83 100644
--- a/configs/theadorable-x86-conga-qa3-e3845_defconfig
+++ b/configs/theadorable-x86-conga-qa3-e3845_defconfig
@@ -64,3 +64,4 @@ CONFIG_USB_ETHER_RTL8152=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_114=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/theadorable-x86-dfi-bt700_defconfig b/configs/theadorable-x86-dfi-bt700_defconfig
index de9701afe6f8..3a8037757e30 100644
--- a/configs/theadorable-x86-dfi-bt700_defconfig
+++ b/configs/theadorable-x86-dfi-bt700_defconfig
@@ -61,3 +61,4 @@ CONFIG_USB_ETHER_RTL8152=y
 CONFIG_FRAMEBUFFER_SET_VESA_MODE=y
 CONFIG_FRAMEBUFFER_VESA_MODE_114=y
 CONFIG_CONSOLE_SCROLL_LINES=5
+# CONFIG_GZIP is not set
diff --git a/configs/wb45n_defconfig b/configs/wb45n_defconfig
index d2de463aaa14..5728cfb45481 100644
--- a/configs/wb45n_defconfig
+++ b/configs/wb45n_defconfig
@@ -40,4 +40,5 @@ CONFIG_NAND_ATMEL=y
 CONFIG_PMECC_CAP=4
 CONFIG_SPL_GENERATE_ATMEL_PMECC_HEADER=y
 CONFIG_LZMA=y
+CONFIG_LZO=y
 CONFIG_OF_LIBFDT=y
diff --git a/configs/x530_defconfig b/configs/x530_defconfig
index 67c8fbf6639f..ab23fd5ab140 100644
--- a/configs/x530_defconfig
+++ b/configs/x530_defconfig
@@ -80,3 +80,4 @@ CONFIG_USB_ETHER_ASIX=y
 CONFIG_USB_ETHER_ASIX88179=y
 CONFIG_WDT=y
 CONFIG_WDT_ORION=y
+CONFIG_LZO=y
diff --git a/configs/xilinx_versal_mini_defconfig b/configs/xilinx_versal_mini_defconfig
index a3b71ccc3e1b..d66707a0ed05 100644
--- a/configs/xilinx_versal_mini_defconfig
+++ b/configs/xilinx_versal_mini_defconfig
@@ -54,4 +54,5 @@ CONFIG_SYS_RELOC_GD_ENV_ADDR=y
 # CONFIG_DM_WARN is not set
 # CONFIG_DM_DEVICE_REMOVE is not set
 # CONFIG_MMC is not set
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_versal_mini_emmc0_defconfig b/configs/xilinx_versal_mini_emmc0_defconfig
index e25077b0006b..1899bb95958c 100644
--- a/configs/xilinx_versal_mini_emmc0_defconfig
+++ b/configs/xilinx_versal_mini_emmc0_defconfig
@@ -53,4 +53,5 @@ CONFIG_SYS_RELOC_GD_ENV_ADDR=y
 CONFIG_MMC_SDHCI=y
 CONFIG_MMC_SDHCI_ZYNQ=y
 CONFIG_FAT_WRITE=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_versal_mini_emmc1_defconfig b/configs/xilinx_versal_mini_emmc1_defconfig
index 3b477ad10368..c5d810e6cd9b 100644
--- a/configs/xilinx_versal_mini_emmc1_defconfig
+++ b/configs/xilinx_versal_mini_emmc1_defconfig
@@ -53,4 +53,5 @@ CONFIG_SYS_RELOC_GD_ENV_ADDR=y
 CONFIG_MMC_SDHCI=y
 CONFIG_MMC_SDHCI_ZYNQ=y
 CONFIG_FAT_WRITE=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_zynqmp_mini_defconfig b/configs/xilinx_zynqmp_mini_defconfig
index c28efa3582a7..b3ad7823c9b8 100644
--- a/configs/xilinx_zynqmp_mini_defconfig
+++ b/configs/xilinx_zynqmp_mini_defconfig
@@ -53,4 +53,5 @@ CONFIG_SYS_RELOC_GD_ENV_ADDR=y
 # CONFIG_DM_DEVICE_REMOVE is not set
 # CONFIG_MMC is not set
 CONFIG_PANIC_HANG=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_zynqmp_mini_emmc0_defconfig b/configs/xilinx_zynqmp_mini_emmc0_defconfig
index cb2983d2476e..d73af31a15d4 100644
--- a/configs/xilinx_zynqmp_mini_emmc0_defconfig
+++ b/configs/xilinx_zynqmp_mini_emmc0_defconfig
@@ -56,4 +56,5 @@ CONFIG_SUPPORT_EMMC_BOOT=y
 CONFIG_MMC_SDHCI=y
 CONFIG_MMC_SDHCI_ZYNQ=y
 CONFIG_PANIC_HANG=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_zynqmp_mini_emmc1_defconfig b/configs/xilinx_zynqmp_mini_emmc1_defconfig
index f7bec364c386..f7cbb7470ca1 100644
--- a/configs/xilinx_zynqmp_mini_emmc1_defconfig
+++ b/configs/xilinx_zynqmp_mini_emmc1_defconfig
@@ -56,4 +56,5 @@ CONFIG_SUPPORT_EMMC_BOOT=y
 CONFIG_MMC_SDHCI=y
 CONFIG_MMC_SDHCI_ZYNQ=y
 CONFIG_PANIC_HANG=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_zynqmp_mini_nand_defconfig b/configs/xilinx_zynqmp_mini_nand_defconfig
index 01e097199155..871bfaf8d39c 100644
--- a/configs/xilinx_zynqmp_mini_nand_defconfig
+++ b/configs/xilinx_zynqmp_mini_nand_defconfig
@@ -52,4 +52,5 @@ CONFIG_MTD_RAW_NAND=y
 CONFIG_NAND_ARASAN=y
 CONFIG_SYS_NAND_MAX_CHIPS=2
 CONFIG_PANIC_HANG=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_zynqmp_mini_nand_single_defconfig b/configs/xilinx_zynqmp_mini_nand_single_defconfig
index 20e76cb11e8b..4b81d3a64f27 100644
--- a/configs/xilinx_zynqmp_mini_nand_single_defconfig
+++ b/configs/xilinx_zynqmp_mini_nand_single_defconfig
@@ -51,4 +51,5 @@ CONFIG_MTD=y
 CONFIG_MTD_RAW_NAND=y
 CONFIG_NAND_ARASAN=y
 CONFIG_PANIC_HANG=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/xilinx_zynqmp_mini_qspi_defconfig b/configs/xilinx_zynqmp_mini_qspi_defconfig
index c6e03cd256d4..075cf71bae37 100644
--- a/configs/xilinx_zynqmp_mini_qspi_defconfig
+++ b/configs/xilinx_zynqmp_mini_qspi_defconfig
@@ -63,4 +63,5 @@ CONFIG_SPI_FLASH_WINBOND=y
 CONFIG_SPI=y
 CONFIG_ZYNQMP_GQSPI=y
 CONFIG_PANIC_HANG=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/zynq_cse_nand_defconfig b/configs/zynq_cse_nand_defconfig
index 6a01da2e4e1f..fcce5304167c 100644
--- a/configs/zynq_cse_nand_defconfig
+++ b/configs/zynq_cse_nand_defconfig
@@ -56,4 +56,5 @@ CONFIG_SPL_DM_SEQ_ALIAS=y
 CONFIG_MTD=y
 CONFIG_MTD_RAW_NAND=y
 CONFIG_NAND_ZYNQ=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/zynq_cse_nor_defconfig b/configs/zynq_cse_nor_defconfig
index 7b18ba3cd534..25173bf6d438 100644
--- a/configs/zynq_cse_nor_defconfig
+++ b/configs/zynq_cse_nor_defconfig
@@ -59,4 +59,5 @@ CONFIG_FLASH_CFI_DRIVER=y
 CONFIG_CFI_FLASH=y
 CONFIG_SYS_FLASH_USE_BUFFER_WRITE=y
 CONFIG_SYS_FLASH_CFI=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/configs/zynq_cse_qspi_defconfig b/configs/zynq_cse_qspi_defconfig
index 15d8473b27ca..b870f340153f 100644
--- a/configs/zynq_cse_qspi_defconfig
+++ b/configs/zynq_cse_qspi_defconfig
@@ -70,4 +70,5 @@ CONFIG_SPI_FLASH_WINBOND=y
 # CONFIG_SPI_FLASH_USE_4K_SECTORS is not set
 CONFIG_DEBUG_UART_ARM_DCC=y
 CONFIG_ZYNQ_QSPI=y
+# CONFIG_GZIP is not set
 # CONFIG_EFI_LOADER is not set
diff --git a/include/configs/dh_imx6.h b/include/configs/dh_imx6.h
index efb3cfee3529..5bfdf4044bee 100644
--- a/include/configs/dh_imx6.h
+++ b/include/configs/dh_imx6.h
@@ -32,8 +32,6 @@
 #define CONFIG_INITRD_TAG
 #define CONFIG_REVISION_TAG
 
-#define CONFIG_BZIP2
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(4 * SZ_1M)
 
diff --git a/include/configs/guruplug.h b/include/configs/guruplug.h
index 768f4ebcbb8d..1e1e5da4d52f 100644
--- a/include/configs/guruplug.h
+++ b/include/configs/guruplug.h
@@ -17,7 +17,6 @@
 /*
  * Standard filesystems
  */
-#define CONFIG_BZIP2
 
 /*
  * mv-plug-common.h should be defined after CMD configs since it used them
diff --git a/include/configs/ib62x0.h b/include/configs/ib62x0.h
index 71738bfb7d8e..f27dbfbc5f64 100644
--- a/include/configs/ib62x0.h
+++ b/include/configs/ib62x0.h
@@ -15,11 +15,6 @@
 #define CONFIG_KW88F6281		/* SOC Name */
 #define CONFIG_SKIP_LOWLEVEL_INIT	/* disable board lowlevel_init */
 
-/*
- * Compression configuration
- */
-#define CONFIG_BZIP2
-
 /*
  * Commands configuration
  */
diff --git a/include/configs/iconnect.h b/include/configs/iconnect.h
index a694b2e92be9..3754cd1e6555 100644
--- a/include/configs/iconnect.h
+++ b/include/configs/iconnect.h
@@ -20,11 +20,6 @@
  */
 #define CONFIG_MACH_TYPE	MACH_TYPE_ICONNECT
 
-/*
- * Compression configuration
- */
-#define CONFIG_BZIP2
-
 /*
  * Commands configuration
  */
diff --git a/include/configs/nsa310s.h b/include/configs/nsa310s.h
index e59ef11e66a7..ce1e3214a690 100644
--- a/include/configs/nsa310s.h
+++ b/include/configs/nsa310s.h
@@ -15,9 +15,6 @@
 #define CONFIG_KW88F6702		1	/* SOC Name */
 #define CONFIG_SKIP_LOWLEVEL_INIT	/* disable board lowlevel_init */
 
-/* compression configuration */
-#define CONFIG_BZIP2
-
 /* commands configuration */
 
 /*
diff --git a/include/configs/sheevaplug.h b/include/configs/sheevaplug.h
index ed5e284077db..3ee6e684fdba 100644
--- a/include/configs/sheevaplug.h
+++ b/include/configs/sheevaplug.h
@@ -21,7 +21,6 @@
 /*
  * Standard filesystems
  */
-#define CONFIG_BZIP2
 
 /*
  * mv-plug-common.h should be defined after CMD configs since it used them
diff --git a/include/configs/wb45n.h b/include/configs/wb45n.h
index aecf2737f8aa..d256ce8e4b9b 100644
--- a/include/configs/wb45n.h
+++ b/include/configs/wb45n.h
@@ -50,7 +50,6 @@
 #define CONFIG_SYS_NAND_READY_PIN   AT91_PIN_PD5
 
 #define CONFIG_RBTREE
-#define CONFIG_LZO
 
 /* Ethernet */
 #define CONFIG_MACB
diff --git a/include/configs/x530.h b/include/configs/x530.h
index 9081f416605e..99531ed31906 100644
--- a/include/configs/x530.h
+++ b/include/configs/x530.h
@@ -71,7 +71,6 @@
 #define CONFIG_SYS_NAND_ONFI_DETECTION
 #define CONFIG_CMD_UBI
 #define CONFIG_CMD_UBIFS
-#define CONFIG_LZO
 #define CONFIG_CMD_MTDPARTS
 
 #define CONFIG_SYS_MALLOC_LEN		(4 << 20)
diff --git a/include/configs/x86-common.h b/include/configs/x86-common.h
index 016b797a534e..ff45714c82c1 100644
--- a/include/configs/x86-common.h
+++ b/include/configs/x86-common.h
@@ -18,8 +18,6 @@
 
 #define CONFIG_LMB
 
-#undef CONFIG_ZLIB
-#undef CONFIG_GZIP
 #define CONFIG_SYS_BOOTM_LEN		(16 << 20)
 
 /* SATA AHCI storage */
diff --git a/include/configs/xilinx_versal_mini.h b/include/configs/xilinx_versal_mini.h
index ae7eca11553f..a1a98f9193b0 100644
--- a/include/configs/xilinx_versal_mini.h
+++ b/include/configs/xilinx_versal_mini.h
@@ -17,8 +17,6 @@
 
 /* Undef unneeded configs */
 #undef CONFIG_EXTRA_ENV_SETTINGS
-#undef CONFIG_ZLIB
-#undef CONFIG_GZIP
 #undef CONFIG_CMD_ENV
 
 /* BOOTP options */
diff --git a/include/configs/xilinx_zynqmp_mini.h b/include/configs/xilinx_zynqmp_mini.h
index 3078b9c55b52..ccc938267d5e 100644
--- a/include/configs/xilinx_zynqmp_mini.h
+++ b/include/configs/xilinx_zynqmp_mini.h
@@ -19,8 +19,6 @@
 #undef CONFIG_BOOTCOMMAND
 #undef CONFIG_EXTRA_ENV_SETTINGS
 #undef CONFIG_SYS_MALLOC_LEN
-#undef CONFIG_ZLIB
-#undef CONFIG_GZIP
 #undef CONFIG_CMD_ENV
 #undef CONFIG_SYS_INIT_SP_ADDR
 
diff --git a/include/configs/zynq_cse.h b/include/configs/zynq_cse.h
index 917f35b24c5f..0491cf51361c 100644
--- a/include/configs/zynq_cse.h
+++ b/include/configs/zynq_cse.h
@@ -15,8 +15,6 @@
 
 /* Undef unneeded configs */
 #undef CONFIG_EXTRA_ENV_SETTINGS
-#undef CONFIG_ZLIB
-#undef CONFIG_GZIP
 
 #undef CONFIG_SYS_CBSIZE
 