diff --git a/README b/README
index bcf198363111..a0f54645fc26 100644
--- a/README
+++ b/README
@@ -670,11 +670,6 @@ The following options need to be configured:
 		Define this variable to enable hw flow control in serial driver.
 		Current user of this option is drivers/serial/nsl16550.c driver
 
-- Console Baudrate:
-		CONFIG_BAUDRATE - in bps
-		Select one of the baudrates listed in
-		CONFIG_SYS_BAUDRATE_TABLE, see below.
-
 - Autoboot Command:
 		CONFIG_BOOTCOMMAND
 		Only needed when CONFIG_BOOTDELAY is enabled;
diff --git a/include/configs/apalis-imx8.h b/include/configs/apalis-imx8.h
index 08d34db1061e..6dad8216e969 100644
--- a/include/configs/apalis-imx8.h
+++ b/include/configs/apalis-imx8.h
@@ -103,9 +103,6 @@
 #define PHYS_SDRAM_1_SIZE		SZ_2G		/* 2 GB */
 #define PHYS_SDRAM_2_SIZE		SZ_2G		/* 2 GB */
 
-/* Serial */
-#define CONFIG_BAUDRATE			115200
-
 /* Monitor Command Prompt */
 #define CONFIG_SYS_PROMPT_HUSH_PS2	"> "
 #define CONFIG_SYS_CBSIZE		SZ_2K
diff --git a/include/configs/bcm_northstar2.h b/include/configs/bcm_northstar2.h
index 45dc7b29c9e4..fbfab288b372 100644
--- a/include/configs/bcm_northstar2.h
+++ b/include/configs/bcm_northstar2.h
@@ -31,7 +31,6 @@
 #define CONFIG_SYS_NS16550_COM2			0x66110000
 #define CONFIG_SYS_NS16550_COM3			0x66120000
 #define CONFIG_SYS_NS16550_COM4			0x66130000
-#define CONFIG_BAUDRATE				115200
 
 /* console configuration */
 #define CONFIG_SYS_CBSIZE			SZ_1K
diff --git a/include/configs/bcmstb.h b/include/configs/bcmstb.h
index 24569f7d94a8..01cfed0b869d 100644
--- a/include/configs/bcmstb.h
+++ b/include/configs/bcmstb.h
@@ -115,7 +115,6 @@ extern phys_addr_t prior_stage_fdt_address;
 /*
  * Serial console configuration.
  */
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_BAUDRATE_TABLE	{4800, 9600, 19200, 38400, 57600, \
 					 115200}
 
diff --git a/include/configs/colibri-imx8x.h b/include/configs/colibri-imx8x.h
index da9226e2fbed..0ac4e7095de9 100644
--- a/include/configs/colibri-imx8x.h
+++ b/include/configs/colibri-imx8x.h
@@ -135,9 +135,6 @@
 #define PHYS_SDRAM_1_SIZE		SZ_2G		/* 2 GB */
 #define PHYS_SDRAM_2_SIZE		0x00000000	/* 0 GB */
 
-/* Serial */
-#define CONFIG_BAUDRATE			115200
-
 /* Monitor Command Prompt */
 #define CONFIG_SYS_PROMPT_HUSH_PS2	"> "
 #define CONFIG_SYS_CBSIZE		SZ_2K
diff --git a/include/configs/controlcenterdc.h b/include/configs/controlcenterdc.h
index 00e5c8f7943e..0c36ea661057 100644
--- a/include/configs/controlcenterdc.h
+++ b/include/configs/controlcenterdc.h
@@ -112,8 +112,6 @@
  */
 #define CONFIG_ENV_OVERWRITE
 
-#define CONFIG_BAUDRATE 115200
-
 #define CONFIG_HOSTNAME		"ccdc"
 #define CONFIG_ROOTPATH		"/opt/nfsroot"
 #define CONFIG_BOOTFILE		"ccdc.img"
diff --git a/include/configs/dh_imx6.h b/include/configs/dh_imx6.h
index 5bfdf4044bee..0b6617fa82e9 100644
--- a/include/configs/dh_imx6.h
+++ b/include/configs/dh_imx6.h
@@ -62,7 +62,6 @@
 /* UART */
 #define CONFIG_MXC_UART
 #define CONFIG_MXC_UART_BASE		UART1_BASE
-#define CONFIG_BAUDRATE			115200
 
 /* USB Configs */
 #ifdef CONFIG_CMD_USB
diff --git a/include/configs/display5.h b/include/configs/display5.h
index 3348ecc7c7ba..94baa6561022 100644
--- a/include/configs/display5.h
+++ b/include/configs/display5.h
@@ -66,7 +66,6 @@
 
 /* allow to overwrite serial and ethaddr */
 #define CONFIG_ENV_OVERWRITE
-#define CONFIG_BAUDRATE			115200
 
 #ifndef CONFIG_BOOTCOMMAND
 #define CONFIG_BOOTCOMMAND "if run check_em_pad; then " \
diff --git a/include/configs/grpeach.h b/include/configs/grpeach.h
index 001e9d385ba1..bde168d47505 100644
--- a/include/configs/grpeach.h
+++ b/include/configs/grpeach.h
@@ -11,9 +11,6 @@
 /* Board Clock , P1 clock frequency (XTAL=13.33MHz) */
 #define CONFIG_SYS_CLK_FREQ	66666666
 
-/* Serial Console */
-#define CONFIG_BAUDRATE		115200
-
 /* Miscellaneous */
 #define CONFIG_SYS_PBSIZE	256
 #define CONFIG_CMDLINE_TAG
diff --git a/include/configs/imx8mq_evk.h b/include/configs/imx8mq_evk.h
index f71efd45abdb..33a301409520 100644
--- a/include/configs/imx8mq_evk.h
+++ b/include/configs/imx8mq_evk.h
@@ -175,8 +175,6 @@
 #define PHYS_SDRAM                      0x40000000
 #define PHYS_SDRAM_SIZE			0xC0000000 /* 3GB DDR */
 
-#define CONFIG_BAUDRATE			115200
-
 #define CONFIG_MXC_UART
 #define CONFIG_MXC_UART_BASE		UART1_BASE_ADDR
 
diff --git a/include/configs/imx8qm_mek.h b/include/configs/imx8qm_mek.h
index 8324767eb557..fd68c4f052e7 100644
--- a/include/configs/imx8qm_mek.h
+++ b/include/configs/imx8qm_mek.h
@@ -175,9 +175,6 @@
 #define PHYS_SDRAM_1_SIZE		0x80000000	/* 2 GB */
 #define PHYS_SDRAM_2_SIZE		0x100000000	/* 4 GB */
 
-/* Serial */
-#define CONFIG_BAUDRATE			115200
-
 /* Generic Timer Definitions */
 #define COUNTER_FREQUENCY		8000000	/* 8MHz */
 
diff --git a/include/configs/imx8qm_rom7720.h b/include/configs/imx8qm_rom7720.h
index 89d7adabea84..9808e72474f0 100644
--- a/include/configs/imx8qm_rom7720.h
+++ b/include/configs/imx8qm_rom7720.h
@@ -163,9 +163,6 @@
 /* LPDDR4 board total DDR is 6GB, DDR4 board total DDR is 4 GB */
 #define PHYS_SDRAM_2_SIZE		0x80000000	/* 2 GB */
 
-/* Serial */
-#define CONFIG_BAUDRATE			115200
-
 /* Generic Timer Definitions */
 #define COUNTER_FREQUENCY		8000000	/* 8MHz */
 
diff --git a/include/configs/imx8qxp_mek.h b/include/configs/imx8qxp_mek.h
index a58f68c17e6c..b442b48becf5 100644
--- a/include/configs/imx8qxp_mek.h
+++ b/include/configs/imx8qxp_mek.h
@@ -175,9 +175,6 @@
 /* LPDDR4 board total DDR is 3GB */
 #define PHYS_SDRAM_2_SIZE		0x40000000	/* 1 GB */
 
-/* Serial */
-#define CONFIG_BAUDRATE			115200
-
 /* Generic Timer Definitions */
 #define COUNTER_FREQUENCY		8000000	/* 8MHz */
 
diff --git a/include/configs/ls1021atsn.h b/include/configs/ls1021atsn.h
index 46c60aaf5cbc..ec2ed7c60969 100644
--- a/include/configs/ls1021atsn.h
+++ b/include/configs/ls1021atsn.h
@@ -104,8 +104,6 @@
 #endif
 #define CONFIG_SYS_NS16550_CLK		get_serial_clock()
 
-#define CONFIG_BAUDRATE			115200
-
 /* I2C */
 #ifndef CONFIG_DM_I2C
 #define CONFIG_SYS_I2C
diff --git a/include/configs/ls1028a_common.h b/include/configs/ls1028a_common.h
index f9040e661d01..44f2dc8f9b41 100644
--- a/include/configs/ls1028a_common.h
+++ b/include/configs/ls1028a_common.h
@@ -48,7 +48,6 @@
 #define CONFIG_SYS_NS16550_REG_SIZE     1
 #define CONFIG_SYS_NS16550_CLK          (get_bus_freq(0) / 2)
 
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
 
 /* Miscellaneous configurable options */
diff --git a/include/configs/ls1088a_common.h b/include/configs/ls1088a_common.h
index 596f14bf3e9e..3ea16752de09 100644
--- a/include/configs/ls1088a_common.h
+++ b/include/configs/ls1088a_common.h
@@ -64,7 +64,6 @@
 #define CONFIG_SYS_NS16550_REG_SIZE     1
 #define CONFIG_SYS_NS16550_CLK          (get_bus_freq(0) / 2)
 
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
 
 #if !defined(SPL_NO_IFC) || defined(CONFIG_TARGET_LS1088AQDS)
diff --git a/include/configs/lx2160a_common.h b/include/configs/lx2160a_common.h
index 5ab924457efb..a8636d398eeb 100644
--- a/include/configs/lx2160a_common.h
+++ b/include/configs/lx2160a_common.h
@@ -78,7 +78,6 @@
 					(void *)CONFIG_SYS_SERIAL1, \
 					(void *)CONFIG_SYS_SERIAL2, \
 					(void *)CONFIG_SYS_SERIAL3 }
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
 
 /* MC firmware */
diff --git a/include/configs/mx53ppd.h b/include/configs/mx53ppd.h
index bb6d82d32749..2ee66612c21b 100644
--- a/include/configs/mx53ppd.h
+++ b/include/configs/mx53ppd.h
@@ -33,7 +33,6 @@
 
 /* allow to overwrite serial and ethaddr */
 #define CONFIG_ENV_OVERWRITE
-#define CONFIG_BAUDRATE			115200
 
 /* Command definition */
 
diff --git a/include/configs/mx6memcal.h b/include/configs/mx6memcal.h
index b774b167f648..0a28d61703a2 100644
--- a/include/configs/mx6memcal.h
+++ b/include/configs/mx6memcal.h
@@ -27,7 +27,6 @@
 #else
 #error please define serial console (CONFIG_SERIAL_CONSOLE_UARTx)
 #endif
-#define CONFIG_BAUDRATE			115200
 
 #define CONFIG_SYS_PBSIZE (CONFIG_SYS_CBSIZE + 16)
 
diff --git a/include/configs/mx7ulp_evk.h b/include/configs/mx7ulp_evk.h
index 942b7dd41483..5e05b8c16693 100644
--- a/include/configs/mx7ulp_evk.h
+++ b/include/configs/mx7ulp_evk.h
@@ -39,7 +39,6 @@
 
 /* allow to overwrite serial and ethaddr */
 #define CONFIG_ENV_OVERWRITE
-#define CONFIG_BAUDRATE			115200
 
 #define CONFIG_SYS_CACHELINE_SIZE      64
 
diff --git a/include/configs/owl-common.h b/include/configs/owl-common.h
index f77a5fa4c114..98b5a96cf61c 100644
--- a/include/configs/owl-common.h
+++ b/include/configs/owl-common.h
@@ -29,9 +29,6 @@
  */
 #define CONFIG_SYS_INIT_SP_ADDR		(CONFIG_SYS_TEXT_BASE + 0x7ff00)
 
-/* UART Definitions */
-#define CONFIG_BAUDRATE			115200
-
 /* Console configuration */
 #define CONFIG_SYS_CBSIZE		1024	/* Console buffer size */
 #define CONFIG_SYS_MAXARGS		64
diff --git a/include/configs/pdu001.h b/include/configs/pdu001.h
index d524f3cbcf01..e4b14c5ecd6b 100644
--- a/include/configs/pdu001.h
+++ b/include/configs/pdu001.h
@@ -73,6 +73,5 @@
 #define CONFIG_SYS_NS16550_COM4	UART3_BASE
 #define CONFIG_SYS_NS16550_COM5	UART4_BASE
 #define CONFIG_SYS_NS16550_COM6	UART5_BASE
-#define CONFIG_BAUDRATE		115200
 
 #endif	/* ! __CONFIG_PDU001_H */
diff --git a/include/configs/pico-imx8mq.h b/include/configs/pico-imx8mq.h
index 2ae13b30ee53..7b7d633f2828 100644
--- a/include/configs/pico-imx8mq.h
+++ b/include/configs/pico-imx8mq.h
@@ -150,8 +150,6 @@
 #define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_MEMTEST_START + \
 					(PHYS_SDRAM_SIZE >> 1))
 
-#define CONFIG_BAUDRATE			115200
-
 #define CONFIG_MXC_UART
 #define CONFIG_MXC_UART_BASE		UART1_BASE_ADDR
 
diff --git a/include/configs/presidio_asic.h b/include/configs/presidio_asic.h
index 51177f44feed..34235b5a00c1 100644
--- a/include/configs/presidio_asic.h
+++ b/include/configs/presidio_asic.h
@@ -41,7 +41,6 @@
 #define CORTINA_SERIAL_PORTS		{(void *)CONFIG_SYS_SERIAL0, \
 					 (void *)CONFIG_SYS_SERIAL1}
 
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_SERIAL0		PER_UART0_CFG
 #define CONFIG_SYS_SERIAL1		PER_UART1_CFG
 
diff --git a/include/configs/rk3128_common.h b/include/configs/rk3128_common.h
index d0c9e5c809df..8f1d508b8ce2 100644
--- a/include/configs/rk3128_common.h
+++ b/include/configs/rk3128_common.h
@@ -9,7 +9,6 @@
 #include "rockchip-common.h"
 
 #define CONFIG_SYS_MAXARGS		16
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_CBSIZE		1024
 #define CONFIG_SKIP_LOWLEVEL_INIT
 
diff --git a/include/configs/rk3368_common.h b/include/configs/rk3368_common.h
index e57d0efa7f92..f178a06945db 100644
--- a/include/configs/rk3368_common.h
+++ b/include/configs/rk3368_common.h
@@ -15,7 +15,6 @@
 
 #define CONFIG_SYS_SDRAM_BASE		0
 #define SDRAM_MAX_SIZE			0xff000000
-#define CONFIG_BAUDRATE			115200
 #define CONFIG_SYS_CBSIZE		1024
 #define CONFIG_SKIP_LOWLEVEL_INIT
 
diff --git a/include/configs/wb50n.h b/include/configs/wb50n.h
index c2112763a2bb..a210449dae49 100644
--- a/include/configs/wb50n.h
+++ b/include/configs/wb50n.h
@@ -72,8 +72,6 @@
 #define CONFIG_BOOTARGS \
     "rw rootfstype=ubifs ubi.mtd=6 root=ubi0:rootfs"
 
-#define CONFIG_BAUDRATE             115200
-
 #define CONFIG_SYS_CBSIZE           1024
 #define CONFIG_SYS_MAXARGS          16
 #define CONFIG_SYS_PBSIZE \